import { Description } from "./Description";
import { SectionHeaderDescription } from "./SectionHeaderDescription";
import { SummaryRowRootDescription } from "./SummaryRowRootDescription";
import { SummaryRowSectionDescription } from "./SummaryRowSectionDescription";
import { RowSeparatorDescription } from "./RowSeparatorDescription";
import { HeaderRowSeparatorDescription } from "./HeaderRowSeparatorDescription";
import { HeaderSeparatorDescription } from "./HeaderSeparatorDescription";
import { ColumnResizingSeparatorDescription } from "./ColumnResizingSeparatorDescription";
import { ColumnMovingSeparatorDescription } from "./ColumnMovingSeparatorDescription";
import { PinnedAreaSeparatorDescription } from "./PinnedAreaSeparatorDescription";
import { BaseDataSourceDescription } from "./BaseDataSourceDescription";
import { GridAnimationSettingsDescription } from "./GridAnimationSettingsDescription";
import { Type } from "./type";
import { PrimaryKeyValueDescription } from "./PrimaryKeyValueDescription";
import { CellKeyDescription } from "./CellKeyDescription";
import { CellRangeDescription } from "./CellRangeDescription";
import { GridCellPositionDescription } from "./GridCellPositionDescription";
import { ResponsiveStateDescription } from "./ResponsiveStateDescription";
import { ColumnSortDescriptionDescription } from "./ColumnSortDescriptionDescription";
import { ColumnGroupDescriptionDescription } from "./ColumnGroupDescriptionDescription";
import { FilterExpressionDescription } from "./FilterExpressionDescription";
import { ColumnSummaryDescriptionDescription } from "./ColumnSummaryDescriptionDescription";
import { ColumnDescription } from "./ColumnDescription";
/**
 * @hidden
 */
export declare class DataGridDescription extends Description {
    static $t: Type;
    private fp;
    width: string;
    private ew;
    height: string;
    private di;
    background: string;
    protected get_type(): string;
    readonly type: string;
    constructor();
    private d9;
    columnResizingMode: string;
    private d1;
    columnMovingMode: string;
    private a5;
    sectionHeader: SectionHeaderDescription;
    private a7;
    summaryRowRoot: SummaryRowRootDescription;
    private a9;
    summaryRowSection: SummaryRowSectionDescription;
    private a3;
    rowSeparator: RowSeparatorDescription;
    private ax;
    headerRowSeparator: HeaderRowSeparatorDescription;
    private az;
    headerSeparator: HeaderSeparatorDescription;
    private ar;
    columnResizingSeparator: ColumnResizingSeparatorDescription;
    private ap;
    columnMovingSeparator: ColumnMovingSeparatorDescription;
    private a1;
    pinnedAreaSeparator: PinnedAreaSeparatorDescription;
    private h;
    autoGenerateDesiredProperties: string[];
    private j;
    dataSourceDesiredProperties: string[];
    private eh;
    density: string;
    private cy;
    actualRowHeight: number;
    private c4;
    rowHeight: number;
    private cb;
    defaultColumnMinWidth: number;
    private cx;
    actualHeaderHeight: number;
    private c1;
    headerHeight: number;
    private ef;
    dataSourceRef: string;
    private an;
    dataSource: BaseDataSourceDescription;
    private eq;
    headerClickAction: string;
    private ei;
    editMode: string;
    private ej;
    editModeClickAction: string;
    private bc;
    autoGenerateColumns: boolean;
    private c5;
    rowSeparatorHeight: number;
    private bj;
    isPlaceholderRenderingEnabled: boolean;
    private dw;
    columnAddingAnimationMode: string;
    private d7;
    columnPropertyUpdatingAnimationMode: string;
    private dm;
    cellDataLoadedAnimationMode: string;
    private ez;
    rowSelectionAnimationMode: string;
    private dt;
    cellSelectionAnimationMode: string;
    private at;
    animationSettings: GridAnimationSettingsDescription;
    private d8;
    columnResizingAnimationMode: string;
    private ec;
    columnShowingAnimationMode: string;
    private d0;
    columnMovingAnimationMode: string;
    private dz;
    columnHidingAnimationMode: string;
    private dx;
    columnExchangingAnimationMode: string;
    private fc;
    selectionMode: string;
    private df;
    activationMode: string;
    private fb;
    selectionBehavior: string;
    private s;
    selectedItems: any[];
    private t;
    selectedKeys: PrimaryKeyValueDescription[];
    private r;
    selectedCells: CellKeyDescription[];
    private q;
    selectedCellRanges: CellRangeDescription[];
    private m;
    pinnedItems: any[];
    private n;
    pinnedKeys: PrimaryKeyValueDescription[];
    private be;
    isColumnOptionsEnabled: boolean;
    private bh;
    isGroupRowSticky: boolean;
    private bi;
    isHeaderSeparatorVisible: boolean;
    private ds;
    cellSelectedBackground: string;
    private e5;
    sectionHeaderSelectedBackground: string;
    private fg;
    summaryRootBackground: string;
    private fl;
    summarySectionBackground: string;
    private cd;
    pinnedRowOpacity: number;
    private _editFontFamily;
    editFontFamily: string;
    private _editFontSize;
    editFontSize: number;
    private _editFontStyle;
    editFontStyle: string;
    private _editFontWeight;
    editFontWeight: string;
    private cc;
    editOpacity: number;
    private eg;
    deletedTextColor: string;
    private ff;
    stickyRowBackground: string;
    private ey;
    pinnedRowBackground: string;
    private ex;
    lastStickyRowBackground: string;
    private av;
    activeCell: GridCellPositionDescription;
    private dk;
    cellBackground: string;
    private du;
    cellTextColor: string;
    private et;
    headerSortIndicatorColor: string;
    private eu;
    headerSortIndicatorStyle: string;
    private _cellFontFamily;
    cellFontFamily: string;
    private _cellFontSize;
    cellFontSize: number;
    private _cellFontStyle;
    cellFontStyle: string;
    private _cellFontWeight;
    cellFontWeight: string;
    private e4;
    sectionHeaderBackground: string;
    private e6;
    sectionHeaderTextColor: string;
    private _sectionHeaderFontFamily;
    sectionHeaderFontFamily: string;
    private _sectionHeaderFontSize;
    sectionHeaderFontSize: number;
    private _sectionHeaderFontStyle;
    sectionHeaderFontStyle: string;
    private _sectionHeaderFontWeight;
    sectionHeaderFontWeight: string;
    private _summaryRootLabelFontFamily;
    summaryRootLabelFontFamily: string;
    private _summaryRootLabelFontSize;
    summaryRootLabelFontSize: number;
    private _summaryRootLabelFontStyle;
    summaryRootLabelFontStyle: string;
    private _summaryRootLabelFontWeight;
    summaryRootLabelFontWeight: string;
    private _summarySectionLabelFontFamily;
    summarySectionLabelFontFamily: string;
    private _summarySectionLabelFontSize;
    summarySectionLabelFontSize: number;
    private _summarySectionLabelFontStyle;
    summarySectionLabelFontStyle: string;
    private _summarySectionLabelFontWeight;
    summarySectionLabelFontWeight: string;
    private fj;
    summaryRootValueTextColor: string;
    private _summaryRootValueFontFamily;
    summaryRootValueFontFamily: string;
    private _summaryRootValueFontSize;
    summaryRootValueFontSize: number;
    private _summaryRootValueFontStyle;
    summaryRootValueFontStyle: string;
    private _summaryRootValueFontWeight;
    summaryRootValueFontWeight: string;
    private _summarySectionValueFontFamily;
    summarySectionValueFontFamily: string;
    private _summarySectionValueFontSize;
    summarySectionValueFontSize: number;
    private _summarySectionValueFontStyle;
    summarySectionValueFontStyle: string;
    private _summarySectionValueFontWeight;
    summarySectionValueFontWeight: string;
    private fo;
    summarySectionValueTextColor: string;
    private fh;
    summaryRootLabelTextColor: string;
    private fm;
    summarySectionLabelTextColor: string;
    private fi;
    summaryRootSelectedBackground: string;
    private fn;
    summarySectionSelectedBackground: string;
    private c3;
    pinnedAreaSeparatorWidth: number;
    private c2;
    headerSeparatorWidth: number;
    private es;
    headerSeparatorBackground: string;
    private ep;
    headerBackground: string;
    private ev;
    headerTextColor: string;
    private _headerFontFamily;
    headerFontFamily: string;
    private _headerFontSize;
    headerFontSize: number;
    private _headerFontStyle;
    headerFontStyle: string;
    private _headerFontWeight;
    headerFontWeight: string;
    private e0;
    rowSeparatorBackground: string;
    private er;
    headerRowSeparatorBackground: string;
    private e3;
    rowSeparatorStickyRowBackground: string;
    private e1;
    rowSeparatorLastStickyRowBackground: string;
    private e2;
    rowSeparatorPinnedRowBackground: string;
    private c0;
    columnResizingSeparatorWidth: number;
    private cz;
    columnMovingSeparatorWidth: number;
    private ea;
    columnResizingSeparatorBackground: string;
    private d2;
    columnMovingSeparatorBackground: string;
    private bo;
    shiftSectionContent: boolean;
    private d3;
    columnOptionsIconAlignment: string;
    private d5;
    columnOptionsIconColor: string;
    private d4;
    columnOptionsIconBehavior: string;
    private dj;
    border: string;
    private b3;
    borderWidthBottom: number;
    private b4;
    borderWidthLeft: number;
    private b5;
    borderWidthRight: number;
    private b6;
    borderWidthTop: number;
    private bk;
    notifyOnAllSelectionChanges: boolean;
    private b8;
    cornerRadiusBottomRight: number;
    private b7;
    cornerRadiusBottomLeft: number;
    private b9;
    cornerRadiusTopLeft: number;
    private ca;
    cornerRadiusTopRight: number;
    private bd;
    isActiveCellStyleEnabled: boolean;
    private p;
    responsiveStates: ResponsiveStateDescription[];
    private u;
    sortDescriptions: ColumnSortDescriptionDescription[];
    private l;
    groupDescriptions: ColumnGroupDescriptionDescription[];
    private k;
    filterExpressions: FilterExpressionDescription[];
    private v;
    summaryDescriptions: ColumnSummaryDescriptionDescription[];
    private fk;
    summaryScope: string;
    private bf;
    isGroupCollapsable: boolean;
    private en;
    groupHeaderDisplayMode: string;
    private bg;
    isGroupExpandedDefault: boolean;
    private eo;
    groupSummaryDisplayMode: string;
    private bb;
    autoAcceptEdits: boolean;
    private o;
    primaryKey: string[];
    private g;
    actualPrimaryKey: string[];
    private f;
    actualColumns: ColumnDescription[];
    private i;
    columns: ColumnDescription[];
    private bn;
    reactsToSortChanges: boolean;
    private bm;
    reactsToGroupChanges: boolean;
    private bl;
    reactsToFilterChanges: boolean;
    private el;
    filterExpressionsChangingRef: string;
    private ek;
    filterExpressionsChangedRef: string;
    private dq;
    cellPreviewPointerDownRef: string;
    private dr;
    cellPreviewPointerUpRef: string;
    private dn;
    cellPointerDownRef: string;
    private dp;
    cellPointerUpRef: string;
    private dl;
    cellClickedRef: string;
    private fe;
    sortDescriptionsChangedRef: string;
    private em;
    groupDescriptionsChangedRef: string;
    private dy;
    columnHiddenChangedRef: string;
    private d6;
    columnPinnedChangedRef: string;
    private dv;
    cellValueChangingRef: string;
    private ed;
    dataCommittedRef: string;
    private ee;
    dataCommittingRef: string;
    private fd;
    sizeChangedRef: string;
    private dh;
    actualColumnsChangedRef: string;
    private eb;
    columnsAutoGeneratedRef: string;
    private e9;
    selectedItemsChangedRef: string;
    private fa;
    selectedKeysChangedRef: string;
    private e8;
    selectedCellsChangedRef: string;
    private dg;
    activeCellChangedRef: string;
    private e7;
    selectedCellRangesChangedRef: string;
}
