import { BaseDataSource } from "./BaseDataSource";
import { IPageCandidatesSink } from "./IPageCandidatesSink";
import { PagePredictionEngine } from "./PagePredictionEngine";
import { IDataSourceDataProvider } from "./IDataSourceDataProvider";
import { IDataSourceVirtualDataProvider } from "./IDataSourceVirtualDataProvider";
import { IExternalVirtualDataSource } from "./IExternalVirtualDataSource";
import { Type } from "./type";
import { ISummaryResult } from "./ISummaryResult";
import { DataSourceRowType } from "./DataSourceRowType";
import { DataSourcePageRequestPriority } from "./DataSourcePageRequestPriority";
import { IDataSource } from "./IDataSource";
import { TransactionEvent } from "./TransactionEvent";
import { DataSourceBatchStartedEventArgs } from "./DataSourceBatchStartedEventArgs";
import { DataSourceBatchCompletedEventArgs } from "./DataSourceBatchCompletedEventArgs";
/**
 * @hidden
 */
export declare class VirtualDataSource extends BaseDataSource implements IPageCandidatesSink {
    static $t: Type;
    constructor();
    private cs;
    private db;
    private dy;
    protected get_isSectionCollapsable(): boolean;
    protected set_isSectionCollapsable(a: boolean): void;
    protected get_isSectionExpandedDefault(): boolean;
    protected set_isSectionExpandedDefault(a: boolean): void;
    protected c5: PagePredictionEngine;
    protected get_actualBaseDataProvider(): IDataSourceDataProvider;
    protected readonly actualBaseDataProvider: IDataSourceDataProvider;
    private cw;
    dataProvider: IDataSourceVirtualDataProvider;
    private cv;
    actualDataProvider: IDataSourceVirtualDataProvider;
    private dx;
    pageSizeRequested: number;
    protected resetCache(): void;
    protected resetCacheOverride(): void;
    private dw;
    maxCachedPages: number;
    protected actualPageSizePopulated: boolean;
    private dh;
    actualPageSize: number;
    private c9;
    protected get_isSortingSupported(): boolean;
    protected get_isFilteringSupported(): boolean;
    protected get_isGroupingSupported(): boolean;
    private c0;
    c1: IExternalVirtualDataSource;
    protected resolveDataProvider(): IDataSourceVirtualDataProvider;
    protected propertyUpdatedOverride(a: string, b: any, c: any): void;
    private d1;
    private ei;
    private eo;
    protected resolveFullCount(a: number): number;
    private en;
    private cq;
    private eg;
    private cr;
    private ef;
    private em;
    private d0;
    private ek;
    protected get_isVirtual(): boolean;
    private c8;
    private df;
    private dg;
    private da;
    private co;
    private ct;
    isPlaceholderItem(a: number): boolean;
    getItemAtIndex(a: number): any;
    private d5;
    private cu;
    private c7;
    private c6;
    getItemPropertyAtIndex(a: number, b: string): any;
    private d6;
    private el;
    private ej;
    addCandidate(a: number, b: DataSourcePageRequestPriority): boolean;
    removeCandidate(a: number): void;
    transformPage(a: number): number[];
    getUnrealizedCount(): number;
    onSetItemOverride(a: number, b: any, c: any): void;
    protected refreshInternalOverride(): void;
    private ep;
    onClearItemsOverride(): void;
    onInsertItemOverride(a: number, b: any): void;
    onRemoveItemOverride(a: number, b: any): void;
    protected get_isItemIndexLookupSupported(): boolean;
    protected get_isKeyIndexLookupSupported(): boolean;
    indexOfItem(a: any): number;
    private dd;
    indexOfKey(a: any[]): number;
    private c4;
    getStickyRowPriority(a: number): number;
    unpinRow(a: any[]): void;
    pinRow(a: any[]): void;
    isRowPinned(a: number): boolean;
    private cp;
    private dq;
    private di;
    private ds;
    private dk;
    private dt;
    private dl;
    private dr;
    private dj;
    private dv;
    private du;
    private dn;
    private dm;
    private dp;
    getStickyRowsInRange(a: number, b: number): number[];
    isExclusivelySticky(a: number): boolean;
    getRowType(a: number): DataSourceRowType;
    private de;
    getIsRowExpandedAtIndex(a: number): boolean;
    setIsRowExpandedAtIndex(a: number, b: boolean): void;
    getRowLevel(a: number): number;
    getRootSummaryRowCount(): number;
    private d9;
    private ea;
    getRootSummaryResults(): ISummaryResult[];
    getSectionSummaryResults(a: number): ISummaryResult[][];
    clone(): IDataSource;
    cloneProperties(a: IDataSource): void;
    private _concurrencyTag;
    concurrencyTag: string;
    protected get_isBatchingEnabled(): boolean;
    protected set_isBatchingEnabled(a: boolean): void;
    updatePropertyAtKey(a: any[], b: string, c: any, d?: boolean): number;
    removeItemByKey(a: any[]): void;
    protected ch(a: TransactionEvent, b: any): void;
    private eh;
    batchStarted: (sender: any, e: DataSourceBatchStartedEventArgs) => void;
    batchCompleted: (sender: any, e: DataSourceBatchCompletedEventArgs) => void;
}
